From af79a8ed425edd721d58b989b9979632c53d6943 Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Jul 07 2015 17:34:56 +0000
Subject: [PATCH 155/1001] Get the subscribe/unsubscribe buttons working.


---

diff --git a/hubs/app.py b/hubs/app.py
index 718b32f..f3157c5 100644
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -228,7 +228,49 @@ def get_widget(session, hub, idx):
     flask.abort(404)
 
 
-
+## Here are a bunch of API methods that should probably be broken out into
+## their own file
+@app.route('/api/hub/<hub>/subscribe', methods=['POST'])
+@login_required
+def hub_subscribe(hub):
+    hub = get_hub(session, hub)
+    user = hubs.models.User.by_openid(session, flask.g.auth.openid)
+    hub.subscribe(session, user)
+    session.commit()
+    return flask.redirect(flask.url_for('hub', name=hub.name))
+
+@app.route('/api/hub/<hub>/unsubscribe', methods=['POST'])
+@login_required
+def hub_unsubscribe(hub):
+    hub = get_hub(session, hub)
+    user = hubs.models.User.by_openid(session, flask.g.auth.openid)
+    try:
+        hub.unsubscribe(session, user)
+    except KeyError:
+        return flask.abort(400)
+    session.commit()
+    return flask.redirect(flask.url_for('hub', name=hub.name))
+
+@app.route('/api/hub/<hub>/join', methods=['POST'])
+@login_required
+def hub_join(hub):
+    hub = get_hub(session, hub)
+    user = hubs.models.User.by_openid(session, flask.g.auth.openid)
+    hub.subscribe(session, user, role='member')
+    session.commit()
+    return flask.redirect(flask.url_for('hub', name=hub.name))
+
+@app.route('/api/hub/<hub>/leave', methods=['POST'])
+@login_required
+def hub_leave(hub):
+    hub = get_hub(session, hub)
+    user = hubs.models.User.by_openid(session, flask.g.auth.openid)
+    try:
+        hub.unsubscribe(session, user, role='member')
+    except KeyError:
+        return flask.abort(400)
+    session.commit()
+    return flask.redirect(flask.url_for('hub', name=hub.name))
 
 
 if __name__ == '__main__':
diff --git a/hubs/models.py b/hubs/models.py
index 9933dd6..ff117ab 100644
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -24,7 +24,6 @@
 import datetime
 import json
 import logging
-import random
 
 import sqlalchemy as sa
 from sqlalchemy import create_engine
@@ -101,6 +100,14 @@ class Association(BASE):
     user = relation("User", backref="associations")
     hub = relation("Hub", backref="associations")
 
+    @classmethod
+    def get(cls, session, hub, user, role):
+        return session.query(cls)\
+            .filter_by(hub=hub)\
+            .filter_by(user=user)\
+            .filter_by(role=role)\
+            .first()
+
 
 class Hub(BASE):
     __tablename__ = 'hubs'
@@ -137,6 +144,18 @@ class Hub(BASE):
         session.add(Association(user=user, hub=self, role=role))
         session.commit()
 
+    def unsubscribe(self, session, user, role='subscriber'):
+        """ Subscribe a user to this hub. """
+        # TODO -- add logic here to manage not adding the user multiple
+        # times, doing different roles, etc.. publish a fedmsg message,
+        # etc...
+        association = Association.get(session, hub=self, user=user, role=role)
+        if not association:
+            raise KeyError("%r is not a %r of %r" % (user, role, self))
+        session.delete(association)
+        session.commit()
+
+
     @classmethod
     def by_name(cls, session, name):
         return session.query(cls).filter_by(name=name).first()
diff --git a/hubs/widgets/stats.py b/hubs/widgets/stats.py
index 67a0e26..3f77a47 100644
--- a/hubs/widgets/stats.py
+++ b/hubs/widgets/stats.py
@@ -1,6 +1,7 @@
 from hubs.hinting import hint, prefixed as _
 from hubs.widgets.chrome import panel
 
+import flask
 import jinja2
 
 chrome = panel()
@@ -10,16 +11,29 @@ template = jinja2.Template("""
     <tr><th>Members</th><th>Subscribers</th></tr>
     <tr class="text-info"><td>{{members | length}}</td><td>{{subscribers | length}}</td></tr>
   </table>
+
   {% if g.auth.logged_in %}
+    <div class="pull-right">
     {% if g.auth.nickname in members %}
-    <div class="pull-right"><button class="btn btn-danger">Resign</button></div>
+    <form action="{{hub_leave_url}}" method="POST">
+        <button class="btn btn-danger">Leave Hub</button>
+    </form>
     {% elif g.auth.nickname in subscribers %}
-    <div class="pull-right"><button class="btn btn-warning">Unsubscribe</button></div>
+    <form action="{{hub_unsubscribe_url}}" method="POST">
+        <button class="btn btn-warning">Unsubscribe</button>
+    </form>
     {% else %}
-    <div class="pull-right"><button class="btn btn-info">Subscribe</button></div>
+    <form action="{{hub_subscribe_url}}" method="POST">
+        <button class="btn btn-info">Subscribe</button>
+    </form>
     {% endif %}
+    </div>
   {% else %}
-    <div class="pull-right"><button class="btn btn-info">Subscribe</button></div>
+    <div class="pull-right">
+        <form action="{{hub_subscribe_url}}" method="POST">
+            <button class="btn btn-info">Subscribe</button>
+        </form>
+    </div>
   {% endif %}
 </div>
 """)
@@ -30,6 +44,10 @@ def data(session, widget):
         owners=[u.username for u in widget.hub.owners],
         members=[u.username for u in widget.hub.members],
         subscribers=[u.username for u in widget.hub.subscribers],
+        hub_leave_url=flask.url_for('hub_leave', hub=widget.hub.name),
+        hub_join_url=flask.url_for('hub_join', hub=widget.hub.name),
+        hub_subscribe_url=flask.url_for('hub_subscribe', hub=widget.hub.name),
+        hub_unsubscribe_url=flask.url_for('hub_unsubscribe', hub=widget.hub.name),
     )
 
 

